/*
	LUSScreenSaver Plugin Interface
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSPictureSetting.h"
#include <qfile.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qwhatsthis.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qpe/config.h>
#include <qpe/qpeapplication.h>
#include <qtextcodec.h>
#include <qfiledialog.h>

#define _T(str) QTextCodec::codecForLocale()->toUnicode(str)

LUSSSPictureSetting::LUSSSPictureSetting( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	if ( ! name )
	{
		setName( "SettingDialog" );
	}

	int xx = 200;
	resize( xx, 108 );

	setCaption( _T( "" ) );

	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSPicture" );
	QString path = cfg.readEntry( "Path" );
	if ( path.isEmpty() || ! QFile::exists( path ) )
	{
		path = QPEApplication::documentDir() + "Image_Files/";
	}
	
	PathEdit = new QLineEdit( this, "PathEdit" );
	PathEdit->setGeometry( QRect( 8, 8, xx - 16, 28 ) );
	PathEdit->setText( path );

	IntervalSpin = new QSpinBox( 1, 600, 1, this, "IntervalSpin" );
	IntervalSpin->setGeometry( QRect( 8, 40, xx - 16, 28 ) );
	IntervalSpin->setSuffix( _T( " " ) );
	IntervalSpin->setValue( cfg.readNumEntry( "Interval", 5 ) );

	PushButton1 = new QPushButton( this, "PushButton1" );
	PushButton1->setGeometry( QRect( 8, 72, xx - 144, 26 ) );
	PushButton1->setText( _T( "Ŭ" ) );

	PushButton2 = new QPushButton( this, "PushButton2" );
	PushButton2->setGeometry( QRect( xx - 118, 72, 110, 26 ) );
	PushButton2->setText( _T( "󥻥" ) );

	connect( PushButton1 ,SIGNAL( clicked() ), this, SLOT( accept() ) );
	connect( PushButton2 ,SIGNAL( clicked() ), this, SLOT( close() ) );
}

void LUSSSPictureSetting::accept()
{
	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSPicture" );

	if ( ! PathEdit->text().isEmpty() )
	{
		cfg.writeEntry( "Path", PathEdit->text() );
	}
	
	cfg.writeEntry( "Interval", IntervalSpin->value() );
	close();
}

void LUSSSPictureSetting::closeEvent( QCloseEvent* e )
{
	e->accept();
}


LUSSSPictureSetting::~LUSSSPictureSetting()
{
    // no need to delete child widgets, Qt does it all for us
}

